#ifndef BASE_PLUGIN_H
#define BASE_PLUGIN_H

#ifdef LINUX
#include <stdint.h>
#endif

#ifdef FREE_BSD5
#include <inttypes.h>
#endif

#ifdef FREE_BSD
#include <sys/inttypes.h>
#endif

#include <string>
#include "base_settings.h"

using namespace std;

class ADMINS;
class USERS;
class TARIFFS;
class TRAFFCOUNTER;
class SETTINGS;
class BASE_STORE;

//-----------------------------------------------------------------------------
class BASE_PLUGIN
{
public:
    virtual                 ~BASE_PLUGIN(){};
    virtual void            SetUsers(USERS * u) = 0;
    virtual void            SetTariffs(TARIFFS * t) = 0;
    virtual void            SetAdmins(ADMINS * a) = 0;
    virtual void            SetTraffcounter(TRAFFCOUNTER * tc) = 0;
    virtual void            SetStore(BASE_STORE * st) = 0;
    virtual void            SetStgSettings(const SETTINGS * s) = 0;
    virtual void            SetSettings(const MODULE_SETTINGS & s) = 0;
    virtual int             ParseSettings() = 0;

    virtual int             Start() = 0;
    virtual int             Stop() = 0;
    virtual bool            IsRunning() = 0;
    virtual const string  & GetStrError() const = 0;
    virtual const string    GetVersion() const = 0;
    virtual uint16_t        GetStartPosition() const = 0;
    virtual uint16_t        GetStopPosition() const = 0;
};
//-----------------------------------------------------------------------------
#endif


