/*
 *****************************************************************************
 *
 * File:        diagram.h
 *
 * Description:  
 *
 * $Id: diagram.h,v 1.1.1.1 2005/10/07 12:15:28 nobunaga Exp $
 *
 *****************************************************************************
 */

#ifndef _DIAGRAM_H_
#define _DIAGRAM_H_


#include <gd.h>

#include "stg_error.h"


#define MAX_ARC_NUM         (10)
#define MAX_ARC_NAME_SIZE   (20)


class DIAGRAM
{
    private:
        char arcName[MAX_ARC_NUM][MAX_ARC_NAME_SIZE];
        double arcPercent[MAX_ARC_NUM];
        int arcNum;

        gdImagePtr img;
        int diaArcColorIndex[MAX_ARC_NUM];
        int clBGround;
        int clBlack;
        int clWhite;
        int clDarkGrey;
        int clGrey;
        int clBorder;


        void ImageColorsInit(gdImagePtr img);
        void PaintTitle(const char * title);
        void PaintArcsSide();
        void PaintArcsWithoutData();
        void PaintArcsWithData();
        void PaintArcs();
        void PaintLegend();
    public:
        DIAGRAM();
        ~DIAGRAM();

        RESULT_DATA AddArcData(const char * arcName, double arcValue,
                double sumValue);
        double GetFreePercent();
        RESULT_DATA DataCheck();
        void Clear();
        RESULT_DATA Make(const char * title, int border);
        RESULT_DATA SaveAsPng(const char * DiaFileName);
        void GetPngData(void ** pngData, int * pngDataSize);
};


#endif  /* _DIAGRAM_H_ */

/* EOF */

