#ifndef SID_H
#define SID_H

#define SID STGSID

#include <time.h>
#include <limits.h>

// #include "../util.lib/bool.h"

#define LOGIN_LEN   (32)    /*TODO       ? */
#define STR_ERR_LEN (512)
#define MAX_SID_LEN (255)

#define SALT        (3951)

//#define SID_BIN_SUBDIR  ("bin/")

//-----------------------------------------------------------------------------
class SID
{
private:
    char    sidsDir[NAME_MAX];
    char    strError[STR_ERR_LEN];
    int     sidTimeOut;
    char    sid[MAX_SID_LEN];

    char *  sidID;

    void    Encode12(char * dst, const char * src, int srcLen);
    char *  CipherSid(char * sid);
    bool  RemoveSid(const char * sid);
    const char * ChooseSid(const char * sid);

public:
    SID();
    ~SID();

    void    SetLocation(const char *);
    const char *  GetLocation(void);
    
    void    SetTimeout(int);
    int     GetTimeout();

    const char * Get();
    bool  Set(const char *sid);
    bool  Create(void);
        
    bool  ReadData(const char * name, void * data, int *length);
    bool  WriteData(const char * name, const void * data, int length);
    
    bool  UpdateSid(void);
    
    bool  RemoveExpired(void);

    char *  GetStrError(void);
    
    //TODO      ,      ;)
    void    SetSidID(const char *);
    char *  GetSidID();
    char *  ExtractSid(char * url);
};
//-----------------------------------------------------------------------------

#endif

