#ifndef STG_LOCKER_H
#define STG_LOCKER_H

#include <pthread.h>

//#define DEBUG_LOCKER

#ifdef DEBUG_LOCKER
#include <stdio.h>
#include <string>
using namespace std;
#endif
//-----------------------------------------------------------------------------
class STG_LOCKER
{
public:
    STG_LOCKER(pthread_mutex_t * m, const char * __file__, int __line__)
        {
        mutex = m;
        #ifdef DEBUG_LOCKER
        printf("Lock: %s:%d %p %p\n", __file__, __line__, this, mutex);
        file = __file__;
        line = __line__;
        #endif
        pthread_mutex_lock(mutex);
        };

    ~STG_LOCKER()
        {
        pthread_mutex_unlock(mutex);
        #ifdef DEBUG_LOCKER
        printf("Unlock: %s:%d %p %p\n", file.c_str(), line, this, mutex);
        #endif
        };
private:
    pthread_mutex_t *mutex;
    #ifdef DEBUG_LOCKER
    string  file;
    int     line;
    #endif
};
//-----------------------------------------------------------------------------

#endif //STG_LOCKER_H
