#ifndef STG_LOGGER_H
#define STG_LOGGER_H

#include <pthread.h>
#include <string>

using namespace std;

const char * LogDate(time_t t);
//-----------------------------------------------------------------------------
class STG_LOGGER;
STG_LOGGER & GetStgLogger();
//-----------------------------------------------------------------------------
class STG_LOGGER_LOCKER
{
public:
    STG_LOGGER_LOCKER(pthread_mutex_t * m) { mutex = m; pthread_mutex_lock(mutex); };
    ~STG_LOGGER_LOCKER() { pthread_mutex_unlock(mutex); };
private:
    pthread_mutex_t *mutex;
};
//-----------------------------------------------------------------------------
class STG_LOGGER
{
friend STG_LOGGER & GetStgLogger();

public:
    ~STG_LOGGER();
    void SetLogFileName(const string & fn);
    void operator()(const char * fmt, ...);

private:
    const char * LogDate(time_t t);
    STG_LOGGER();
    string fileName;
    pthread_mutex_t mutex;
};
//-----------------------------------------------------------------------------


#endif //STG_LOGGER_H
