/*
 *****************************************************************************
 * $Id: stg_stat.h,v 1.6 2006/06/06 12:53:10 aforizm Exp $
 *****************************************************************************
 */
#ifndef _STG_STAT_H_
#define _STG_STAT_H_


#include <time.h>


#define MAX_PATH_SIZE           (255)
#define MAX_UNAME_SIZE          (32)    /* past value = 20 */
#define MAX_OUT_FILE_NAME_SIZE  (100)
#define MAX_DIR_NUM             (10)


typedef unsigned int        u16;
typedef unsigned long       u32;
typedef unsigned long long  u64;
typedef double              money;
typedef float               percent;

/* */
struct total_stat
{
    total_stat()
        {
        memset(this, 0, sizeof(total_stat));
        }
    time_t fromDT;
    time_t tillDT;
    u64 upLoad[MAX_DIR_NUM];
    u64 downLoad[MAX_DIR_NUM];
    // u64 bothLoad[MAX_DIR_NUM];  /* UpLoad + DownLoad */
    u64 maxLoad[MAX_DIR_NUM];
    money cash[MAX_DIR_NUM];
    u64 sumUpLoad;
    u64 sumDownLoad;
    // u64 sumBothLoad;
    u64 sumMaxLoad;
    money sumCash;
};

struct LINE_STAT
{
    LINE_STAT()
        {
        num = 0;
        memset(u, 0, MAX_DIR_NUM * sizeof(u64));
        memset(d, 0, MAX_DIR_NUM * sizeof(u64));
        dcash = 0;
        memset(&time, 0, sizeof(time));
        }
    u16         num;
    struct tm   time;
    u64         u[MAX_DIR_NUM];
    u64         d[MAX_DIR_NUM];
    money       dcash;
    // percent     pos;
    // percent     width;
    // char        err_flag;
};

struct STG_STAT 
{
    STG_STAT()
        {
        memset(users_path, 0, MAX_PATH_SIZE);
        memset(user, 0, MAX_UNAME_SIZE);
        memset(&from_date,  0, sizeof(from_date));
        memset(&to_date,    0, sizeof(to_date));
        memset(&cur_date,   0, sizeof(cur_date));
        cur_path = NULL;
        fd = 0;
        td = 0;
        }
    char        users_path[MAX_PATH_SIZE];
    struct tm   from_date;
    struct tm   to_date;
    char        user[MAX_UNAME_SIZE];
    // char        fout_name[MAX_OUT_FILE_NAME_SIZE];
    // FILE        *fout;
    // FILE        *flog;
    LINE_STAT   line_stat;
    total_stat  totalStat;
    time_t      fd;             /* fd = from_date */
    time_t      td;             /* td = to_date */
    struct tm   cur_date;       /* date of processing file */
    char        *cur_path;      /* pointer to path on processed file */
    // percent     date_percent;   /* 1% of position  = (td - fd) / 100 */
};

void GetUserTotalStat(STG_STAT * _stg_stat);
//int processing_file(STG_STAT * _stg_stat, FILE * _fin, char * _path);
int processing(STG_STAT * _stg_stat);
#endif /* _STG_STAT_H_ */

/* EOF */

