 /*
 $Revision: 1.8 $
 $Date: 2006/10/13 06:42:12 $
 */

#ifndef USER_CONF_H
#define USER_CONF_H

#ifdef LINUX
#include <stdint.h>
#endif

#ifdef FREE_BSD5
#include <inttypes.h>
#endif

#ifdef FREE_BSD
#include <sys/inttypes.h>
#endif

#include <string>
#include <vector>
#include "stg_const.h"
#include "user_ips.h"
#include "resetable.h"

using namespace std;

//-----------------------------------------------------------------------------
struct USER_CONF
{
    USER_CONF()
    {
        password = "";
        passive = 0;
        disabled = 0;
        alwaysOnline = 0;
        tariffName = "";
        address = "";
        phone = "";
        email = "";
        note = "";
        realName = "";
        group = "";
        credit = 0;
        nextTariff = "";
        creditExpire = 0;
        userdata.resize(USERDATA_NUM);
    };

    string          password;
    int             passive;
    int             disabled;
    int             alwaysOnline;
    string          tariffName;
    string          address;
    string          phone;
    string          email;
    string          note;
    string          realName;
    string          corp;
    vector<string>  service;
    string          group;
    double          credit;
    string          nextTariff;
    vector<string>  userdata;
    time_t          creditExpire;
    USER_IPS        ips;
};
//-----------------------------------------------------------------------------
struct USER_CONF_RES
{
    USER_CONF_RES ()
    {
        userdata.resize(USERDATA_NUM);
        for (int i = 0; i < USERDATA_NUM; i++)
            {
            userdata[i].reset();
            }
        password.reset();
        passive.reset();
        disabled.reset();
        alwaysOnline.reset();
        tariffName.reset();
        address.reset();
        phone.reset();
        email.reset();
        note.reset();
        realName.reset();
        group.reset();
        credit.reset();
        nextTariff.reset();
        creditExpire.reset();
        ips.reset();
    };

    USER_CONF_RES & operator= (const USER_CONF & uc)
    {
        userdata.resize(USERDATA_NUM);
        password     = uc.password;
        passive      = uc.passive;
        disabled     = uc.disabled;
        alwaysOnline = uc.alwaysOnline;
        tariffName   = uc.tariffName;
        address      = uc.address;
        phone        = uc.phone;
        email        = uc.email;
        note         = uc.note;
        realName     = uc.realName;
        group        = uc.group;
        credit       = uc.credit;
        nextTariff   = uc.nextTariff;
        for (int i = 0; i < USERDATA_NUM; i++)
            {
            userdata[i]  = uc.userdata[i];
            }
        creditExpire = uc.creditExpire;
        ips          = uc.ips;
        return *this;
    };
    operator USER_CONF() const
    {
        USER_CONF uc;
        uc.password     = password;
        uc.passive      = passive;
        uc.disabled     = disabled;
        uc.alwaysOnline = alwaysOnline;
        uc.tariffName   = tariffName;
        uc.address      = address;
        uc.phone        = phone;
        uc.email        = email;
        uc.note         = note;
        uc.realName     = realName;
        uc.group        = group;
        uc.credit       = credit;
        uc.nextTariff   = nextTariff;
        for (int i = 0; i < USERDATA_NUM; i++)
            {
            uc.userdata[i]  = userdata[i];
            }
        uc.creditExpire = creditExpire;
        uc.ips          = ips;
        return uc;
    }
    //-------------------------------------------------------------------------

    RESETABLE<string>      password;
    RESETABLE<int>         passive;
    RESETABLE<int>         disabled;
    RESETABLE<int>         alwaysOnline;
    RESETABLE<string>      tariffName;
    RESETABLE<string>      address;
    RESETABLE<string>      phone;
    RESETABLE<string>      email;
    RESETABLE<string>      note;
    RESETABLE<string>      realName;
    RESETABLE<string>      group;
    RESETABLE<double>      credit;
    RESETABLE<string>      nextTariff;
    vector< RESETABLE<string> > userdata;
    //RESETABLE<string>      userdata1;
    RESETABLE<time_t>      creditExpire;
    RESETABLE<USER_IPS>    ips;
};
//-----------------------------------------------------------------------------
#endif

