 /*
 $Revision: 1.8 $
 $Date: 2005/12/21 23:35:01 $
 */

#ifndef USER_STAT_H
#define USER_STAT_H

#ifdef LINUX
#include <stdint.h>
#endif

#ifdef FREE_BSD5
#include <inttypes.h>
#endif

#ifdef FREE_BSD
#include <sys/inttypes.h>
#endif

#include <sstream>
#include <iostream>
#include <sys/types.h>
#include <netinet/in.h>

#include "stg_const.h"
#include "resetable.h"
#include "user_traff.h"
//-----------------------------------------------------------------------------
struct IP_DIR_PAIR
{
    //------------------------
    bool operator< (const IP_DIR_PAIR & idp) const
        {
        if (ip < idp.ip)
            return true;

        if (ip > idp.ip)
            return false;
        
        if (dir < idp.dir)
            return true;
        
        return false;
        }
    //------------------------
    uint32_t        ip;
    int             dir;
};
//-----------------------------------------------------------------------------
struct STAT_NODE
{
    uint64_t        up;
    uint64_t        down;
    double          cash;
};
//-----------------------------------------------------------------------------
struct USER_STAT
{
    //USER_STAT & operator= (const USER_STAT_RES & usr);
    USER_STAT()
        {
            cash = 0;
            freeMb = 0;
            freeMb = 0;            
            lastCashAdd = 0;       
            lastCashAddTime = 0;   
            passiveTime = 0; 
            lastActivityTime = 0;
        };
    
    DIR_TRAFF   up;
    DIR_TRAFF   down;
    double      cash;
    double      freeMb;
    double      lastCashAdd;
    time_t      lastCashAddTime;
    time_t      passiveTime;
    time_t      lastActivityTime;
};
//-----------------------------------------------------------------------------
struct USER_STAT_RES
{
    USER_STAT_RES & operator= (const USER_STAT & us)
    {
        cash             = us.cash;             
        freeMb           = us.freeMb;           
        lastCashAdd      = us.lastCashAdd;      
        lastCashAddTime  = us.lastCashAddTime;  
        passiveTime      = us.passiveTime;      
        lastActivityTime = us.lastActivityTime; 
        up = us.up;
        down = us.down;
        return * this;
    };
    operator USER_STAT()
    {                 
        USER_STAT us;
        us.cash             = cash;             
        us.freeMb           = freeMb;           
        us.lastCashAdd      = lastCashAdd;      
        us.lastCashAddTime  = lastCashAddTime;  
        us.passiveTime      = passiveTime;      
        us.lastActivityTime = lastActivityTime; 
        us.up               = up;
        us.down             = down;
        return us;
    };

    RESETABLE<double>      cash;
    RESETABLE<double>      freeMb;
    RESETABLE<double>      lastCashAdd;
    RESETABLE<time_t>      lastCashAddTime;
    RESETABLE<time_t>      passiveTime;
    RESETABLE<time_t>      lastActivityTime;
    RESETABLE<DIR_TRAFF>   up;
    RESETABLE<DIR_TRAFF>   down;
};
//-----------------------------------------------------------------------------
#endif



