#ifndef _SMTP_H_
#define _SMTP_H_
//---------------------------------------------------------------------------

//#define WINDOWS

#ifdef WINDOWS
    #include <winsock2.h>
#else
    #include <sys/types.h>
    #include <sys/socket.h>
    #include <netinet/in.h>
    #include <netdb.h>
    #include <arpa/inet.h>
#endif

//---------------------------------------------------------------------------
#define CONNECTION_CHECK    0
#define HELLO_CHECK         1
#define MAIL_CHECK          2
#define RCPT_CHECK          3
#define DATA_START_CHECK    4
#define DATA_END_CHECK      5
#define QUIT_CHECK          6
#define DATA_CHECK          7

#define STR_LEN             255

class SMTP
{
public:
    SMTP();
    ~SMTP();

    int     Connect();
    int     Mail();
    int     Data();
    int     Send(const char * body);
    int     SendTo();
    int     SendDot();
    int     Disconnect();

    void    SetSubject(const char * subj);
    char   *GetSubject();

    void    SetTo(const char * to);
    char   *GetTo();

    void    SetFrom(const char * from);
    char   *GetFrom();

    void    SetPort(unsigned short);
    unsigned short    GetPort();

    void    SetHost(const char * host);
    char   *GetHost();

    char   *GetErrorMessage();

private:
    char   *GetError(char * response);
    int     CheckResponse(int type);
    bool    IsError(int res);

    char    to[STR_LEN];
    char    from[STR_LEN];
    char    host[STR_LEN];
    char    subject[STR_LEN];
    char    error[STR_LEN];

    #ifdef WINDOWS
    WSADATA wsaData;
    #endif
    char    charset[20];
    int     SMTPSocket;
    unsigned short port;
    struct  sockaddr_in outerAddr;
    struct  sockaddr_in localAddr;
   };

#endif /* _SMTP_H_ */

