#ifndef HTMLER_H
#define HTMLER_H

#include <string>
#include <vector>

#include "pinger.h"

//-----------------------------------------------------------------------------
class HTMLER
{
public:
    HTMLER();
    ~HTMLER() {};

    void        SetFileName(const std::string & fileName);
    void        SetTplFileName(const std::string & fileName);
    void        SetHTMLUpdatePeriod(time_t period);
    void        SetHTMLEncoding(const string & encoding);

    int         WriteHtml(const std::vector<PINGER> & pinger) const;
    std::string GetStrError() const;

protected:
    std::string         fileName;
    std::string         tplFileName;
    std::string         HTMLEncoding;
    time_t              htmlUpdatePeriod;
    mutable std::string strError;
    char                ver[100];

    int                 WriteTpl() const;
    int                 ReadTpl() const;
    void                RemoveTpl() const;

    mutable char        tplBuff[100000];
};
//-----------------------------------------------------------------------------

#endif

