#include <algorithm>

#include "packet_parser.h"

//-----------------------------------------------------------------------------
PACKET_PARSER::PACKET_PARSER(vector<PINGER> * pingers)
:png(pingerParams), pingers(pingers)
{

}
//-----------------------------------------------------------------------------
int PACKET_PARSER::Parse(uint32_t ip, const char * buffer, int len) const
{
#ifndef DISABLE_PINGER_V1
if (len == 74)
    {
    ProcessPinger_v1(ip, buffer, len);
    return 0;
    }
#endif

#ifndef DISABLE_PINGER_V2
if (len == 35)
    {
    ProcessPinger_v2(ip, buffer, len);
    return 0;
    }
#endif

return -1;
}
//-----------------------------------------------------------------------------
bool PACKET_PARSER::GetBit(int num) const
{
return byte & (1 << num);
}
//-----------------------------------------------------------------------------
int PACKET_PARSER::GetACP() const
{
return acp;
}
//-----------------------------------------------------------------------------
int PACKET_PARSER::ProcessPinger_v1(uint32_t ip, const char * buffer, int len) const
{
vector<PINGER>::iterator iter;

png.SetIP(ip);
iter = find(pingers->begin(), pingers->end(), png);
if (iter == pingers->end())
    {
    strError = "Pinger with IP \'" + string(inet_ntostr(ip)) + "\' not found";
    return -1;
    }
iter->Update(buffer[0], 36, 1);
return 0;
}
//-----------------------------------------------------------------------------
int PACKET_PARSER::ProcessPinger_v2(uint32_t ip, const char * buffer, int len) const
{
vector<PINGER>::iterator iter;

png.SetIP(ip);
//iter = pingers->find(png);
iter = find(pingers->begin(), pingers->end(), png);
if (iter == pingers->end())
    {
    strError = "Pinger with IP \'" + string(inet_ntostr(ip)) + "\' not found";
    return -1;
    }

unsigned char t = static_cast<unsigned char>(buffer[20] | buffer[29]*16);

iter->Update(buffer[0] | buffer[9]*16, t, 2);
return 0;
}
//-----------------------------------------------------------------------------


