#ifndef PACKET_PARSE_H
#define PACKET_PARSE_H

#include <vector>

#include "pinger.h"

//-----------------------------------------------------------------------------
struct BYTE
{
    unsigned char b0:1;
    unsigned char b1:1;
    unsigned char b2:1;
    unsigned char b3:1;
    unsigned char b4:1;
    unsigned char b5:1;
    unsigned char b6:1;
    unsigned char b7:1;
};
//-----------------------------------------------------------------------------
class PACKET_PARSER
{
public:
    PACKET_PARSER(std::vector<PINGER> * pingers);
    virtual ~PACKET_PARSER() {};
    int     Parse(uint32_t ip, const char * buffer, int len) const;

    bool    GetBit(int num) const;
    int     GetACP() const;

protected:

    unsigned char   byte;
    int     acp;

    int     ProcessPinger_v1(uint32_t ip, const char * buffer, int len) const;
    int     ProcessPinger_v2(uint32_t ip, const char * buffer, int len) const;

    PingerParams                    pingerParams;
    mutable PINGER                  png;
    mutable std::vector<PINGER>   * pingers;
    mutable std::string             strError;
};
//-----------------------------------------------------------------------------
#endif

